{% extends "elections2021/base.html" %}
{% load static wagtailcore_tags wagtailimages_tags %}

{% block content_header %}
{% include "elections2021/_page_header.html" with title=page.title photo=page.photo %}
{% endblock %}

{% block content %}

<div class="container container-default pt-16 pb-20 grid grid-cols-6 grid-flow-row gap-2">

  <div class="col-span-6 xl:col-span-2 pl-5 relative">
    <div class="floating-nav-wrapper floating-nav-wrapper--government hidden xl:block" id="floatingNavBarWrapper">
      <div class="floating-nav-panel " id="floatingNavBar">
        <div class="inner float-panel-inner elevation-2">
          <ul>
            {% for section in page.sections %}
              <li><a href="#{{ section.value.title|slugify }}" class="">{{ section.value.title }}</a></li>
            {% endfor %}
          </ul>
        </div>
      </div>
    </div>
    <script>
      window.addEventListener("load", onLoadFunction);
      var anchorsArray = [];

      function placeUponId(id, space) {
        return document.getElementById(id).getBoundingClientRect().top + window.scrollY - space;
      }

      function onLoadFunction(e) {
        var anchorElemsArray;
        onResizeFunction();
        for (const entry of anchorsArray) {
          entry.menuitem.addEventListener("click", clickHandler);
        }

        function clickHandler(e) {
          e.preventDefault();
          var id = this.getAttribute("href").replace("#", "");
          //console.log(placeUponId(id, 20));
          scroll({
            top: placeUponId(id, 20),
            behavior: "smooth"
          });
        }


        window.addEventListener("resize", onResizeFunction);
      }

      function onResizeFunction(e) {
        var itemsProcessed = 0;
        var anchorElemsArray = document.getElementsByClassName("float-panel-inner")[0].querySelectorAll("li a");
        anchorsArray = [];
        anchorElemsArray.forEach(function(entry) {
          var id = entry.getAttribute("href").replace("#", "");
          anchorsArray.push({
            id: id,
            top: placeUponId(id, 200),
            menuitem: entry
          });
          itemsProcessed++;
          if (itemsProcessed === anchorElemsArray.length) {
            anchorsArray.reverse();
          }
        });
        //console.log(anchorsArray);
      }
      window.onscroll = function() {
        var top = window.pageYOffset || document.documentElement.scrollTop;
        var activereached = false;
        anchorsArray.forEach(function(entry) {
          entry.menuitem.classList.remove("active");
          entry.menuitem.classList.remove("passed");
          if (top >= placeUponId(entry.id, 200)) {
            if (activereached) entry.menuitem.classList.add("passed");
            else entry.menuitem.classList.add("active");
            activereached = true;
          }
        });
      };
    </script>
  </div>
  <div class="col-span-6 xl:col-span-4">
    <div class="w-full xl:w-5/6">

      {% for section in page.sections %}
        {% include_block section %}
      {% endfor %}

    </div>
  </div>

</div>

{% endblock %}
